org.apache.pdfbox.cos

## Class COSDictionary

- java.lang.Object
- - org.apache.pdfbox.cos.COSBase
  - - org.apache.pdfbox.cos.COSDictionary

All Implemented Interfaces:
  COSUpdateInfo, COSObjectable

Direct Known Subclasses:
  COSStream

    public class COSDictionary
    extends COSBase
    implements COSUpdateInfo

This class represents a dictionary where name/value pairs reside.

Author:
  Ben Litchfield

### Field Summary

Fields
`protected Map<COSName,COSBase>` `items` The name-value pairs of this dictionary.

### Constructor Summary

Constructors
Constructor and Description
`COSDictionary()` Constructor.
`COSDictionary(COSDictionary dict)` Copy Constructor.

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`Object` `accept(ICOSVisitor visitor)` visitor pattern double dispatch method.
`void` `addAll(COSDictionary dict)` This will add all of the dictionaries keys/values to this dictionary.
`COSDictionary` `asUnmodifiableDictionary()` Returns an unmodifiable view of this dictionary.
`void` `clear()` This will clear all items in the map.
`boolean` `containsKey(COSName name)`
`boolean` `containsKey(String name)`
`boolean` `containsValue(Object value)`
`Set<Map.Entry<COSName,COSBase>>` `entrySet()` Returns the name-value entries in this dictionary.
`boolean` `getBoolean(COSName key, boolean defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a COSBoolean and convert it to a primitive boolean.
`boolean` `getBoolean(COSName firstKey, COSName secondKey, boolean defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a COSBoolean and convert it to a primitive boolean.
`boolean` `getBoolean(String key, boolean defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a cos boolean and convert it to a primitive boolean.
`COSArray` `getCOSArray(COSName key)` This is a convenience method that will get the dictionary object that is expected to be a COSArray.
`COSDictionary` `getCOSDictionary(COSName key)` This is a convenience method that will get the dictionary object that is expected to be a COSDictionary.
`COSName` `getCOSName(COSName key)` This is a convenience method that will get the dictionary object that is expected to be a name.
`COSName` `getCOSName(COSName key, COSName defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a name.
`COSObject` `getCOSObject(COSName key)` This is a convenience method that will get the dictionary object that is expected to be a COSObject.
`COSStream` `getCOSStream(COSName key)` This is a convenience method that will get the dictionary object that is expected to be a COSStream.
`Calendar` `getDate(COSName key)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`Calendar` `getDate(COSName key, Calendar defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a date.
`Calendar` `getDate(String key)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`Calendar` `getDate(String key, Calendar defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a date.
`COSBase` `getDictionaryObject(COSName key)` This will get an object from this dictionary.
`COSBase` `getDictionaryObject(COSName firstKey, COSName secondKey)` This is a special case of getDictionaryObject that takes multiple keys, it will handle the situation where multiple keys could get the same value, ie if either CS or ColorSpace is used to get the colorspace.
`COSBase` `getDictionaryObject(String key)` This will get an object from this dictionary.
`COSBase` `getDictionaryObject(String[] keyList)` Deprecated. Will be removed in 3.0. A value may have to keys, the regular one and sometimes an additional abbreviation. More than 2 values doesn't make sense.
`Calendar` `getEmbeddedDate(String embedded, COSName key)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`Calendar` `getEmbeddedDate(String embedded, COSName key, Calendar defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a date.
`Calendar` `getEmbeddedDate(String embedded, String key)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`Calendar` `getEmbeddedDate(String embedded, String key, Calendar defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a date.
`int` `getEmbeddedInt(String embeddedDictionary, COSName key)` Get an integer from an embedded dictionary.
`int` `getEmbeddedInt(String embeddedDictionary, COSName key, int defaultValue)` Get an integer from an embedded dictionary.
`int` `getEmbeddedInt(String embeddedDictionary, String key)` Get an integer from an embedded dictionary.
`int` `getEmbeddedInt(String embeddedDictionary, String key, int defaultValue)` Get an integer from an embedded dictionary.
`String` `getEmbeddedString(String embedded, COSName key)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`String` `getEmbeddedString(String embedded, COSName key, String defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`String` `getEmbeddedString(String embedded, String key)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`String` `getEmbeddedString(String embedded, String key, String defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`boolean` `getFlag(COSName field, int bitFlag)` Gets the boolean value from the flags at the given bit position.
`float` `getFloat(COSName key)` This is a convenience method that will get the dictionary object that is expected to be an float.
`float` `getFloat(COSName key, float defaultValue)` This is a convenience method that will get the dictionary object that is expected to be an float.
`float` `getFloat(String key)` This is a convenience method that will get the dictionary object that is expected to be an float.
`float` `getFloat(String key, float defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a float.
`int` `getInt(COSName key)` This is a convenience method that will get the dictionary object that is expected to be an int.
`int` `getInt(COSName firstKey, COSName secondKey)` This is a convenience method that will get the dictionary object that is expected to be an integer.
`int` `getInt(COSName firstKey, COSName secondKey, int defaultValue)` This is a convenience method that will get the dictionary object that is expected to be an integer.
`int` `getInt(COSName key, int defaultValue)` This is a convenience method that will get the dictionary object that is expected to be an integer.
`int` `getInt(String key)` This is a convenience method that will get the dictionary object that is expected to be an int.
`int` `getInt(String[] keyList, int defaultValue)` Deprecated. Will be removed in 3.0. A value may have to keys, the regular one and sometimes an additional abbreviation. More than 2 values doesn't make sense.
`int` `getInt(String key, int defaultValue)` This is a convenience method that will get the dictionary object that is expected to be an integer.
`COSBase` `getItem(COSName key)` This will do a lookup into the dictionary.
`COSBase` `getItem(COSName firstKey, COSName secondKey)` This is a special case of getItem that takes multiple keys, it will handle the situation where multiple keys could get the same value, ie if either CS or ColorSpace is used to get the colorspace.
`COSBase` `getItem(String key)` This will do a lookup into the dictionary.
`COSName` `getKeyForValue(Object value)` Search in the map for the value that matches the parameter and return the first key that maps to that value.
`long` `getLong(COSName key)` This is a convenience method that will get the dictionary object that is expected to be an long.
`long` `getLong(COSName key, long defaultValue)` This is a convenience method that will get the dictionary object that is expected to be an integer.
`long` `getLong(String key)` This is a convenience method that will get the dictionary object that is expected to be an long.
`long` `getLong(String[] keyList, long defaultValue)` Deprecated. Will be removed in 3.0. A value may have to keys, the regular one and sometimes an additional abbreviation. More than 2 values doesn't make sense.
`long` `getLong(String key, long defaultValue)` This is a convenience method that will get the dictionary object that is expected to be an integer.
`String` `getNameAsString(COSName key)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`String` `getNameAsString(COSName key, String defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`String` `getNameAsString(String key)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`String` `getNameAsString(String key, String defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.
`COSBase` `getObjectFromPath(String objPath)` Nice method, gives you every object you want Arrays works properly too.
`String` `getString(COSName key)` This is a convenience method that will get the dictionary object that is expected to be a string.
`String` `getString(COSName key, String defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a string.
`String` `getString(String key)` This is a convenience method that will get the dictionary object that is expected to be a string.
`String` `getString(String key, String defaultValue)` This is a convenience method that will get the dictionary object that is expected to be a string.
`Collection<COSBase>` `getValues()` This will get all of the values for the dictionary.
`boolean` `isNeedToBeUpdated()` Get the update state for the COSWriter.
`Set<COSName>` `keySet()` Returns the names of the entries in this dictionary.
`void` `mergeInto(COSDictionary dic)` Deprecated. This method should no longer be used and will be removed in 3.0 because it could also merge attributes that should not be merged (filter and length) in a COSStream.
`void` `removeItem(COSName key)` This will remove an item for the dictionary.
`void` `setBoolean(COSName key, boolean value)` This will set an item in the dictionary.
`void` `setBoolean(String key, boolean value)` This will set an item in the dictionary.
`void` `setDate(COSName key, Calendar date)` Set the date object.
`void` `setDate(String key, Calendar date)` Set the value of a date entry in the dictionary.
`void` `setEmbeddedDate(String embedded, COSName key, Calendar date)` Set the date object.
`void` `setEmbeddedDate(String embedded, String key, Calendar date)` Set the value of a date entry in the dictionary.
`void` `setEmbeddedInt(String embeddedDictionary, COSName key, int value)` This is a convenience method that will convert the value to a COSInteger object.
`void` `setEmbeddedInt(String embeddedDictionary, String key, int value)` This is a convenience method that will convert the value to a COSInteger object.
`void` `setEmbeddedString(String embedded, COSName key, String value)` This is a convenience method that will convert the value to a COSString object.
`void` `setEmbeddedString(String embedded, String key, String value)` This is a convenience method that will convert the value to a COSString object.
`void` `setFlag(COSName field, int bitFlag, boolean value)` Sets the given boolean value at bitPos in the flags.
`void` `setFloat(COSName key, float value)` This is a convenience method that will convert the value to a COSFloat object.
`void` `setFloat(String key, float value)` This is a convenience method that will convert the value to a COSFloat object.
`void` `setInt(COSName key, int value)` This is a convenience method that will convert the value to a COSInteger object.
`void` `setInt(String key, int value)` This is a convenience method that will convert the value to a COSInteger object.
`void` `setItem(COSName key, COSBase value)` This will set an item in the dictionary.
`void` `setItem(COSName key, COSObjectable value)` This will set an item in the dictionary.
`void` `setItem(String key, COSBase value)` This will set an item in the dictionary.
`void` `setItem(String key, COSObjectable value)` This will set an item in the dictionary.
`void` `setLong(COSName key, long value)` This is a convenience method that will convert the value to a COSInteger object.
`void` `setLong(String key, long value)` This is a convenience method that will convert the value to a COSInteger object.
`void` `setName(COSName key, String value)` This is a convenience method that will convert the value to a COSName object.
`void` `setName(String key, String value)` This is a convenience method that will convert the value to a COSName object.
`void` `setNeedToBeUpdated(boolean flag)` Set the update state of the dictionary for the COSWriter.
`void` `setString(COSName key, String value)` This is a convenience method that will convert the value to a COSString object.
`void` `setString(String key, String value)` This is a convenience method that will convert the value to a COSString object.
`int` `size()` This will return the number of elements in this dictionary.
`String` `toString()`

### Methods inherited from class org.apache.pdfbox.cos.COSBase

`getCOSObject, isDirect, setDirect`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### items

    protected Map<COSName,COSBase> items

The name-value pairs of this dictionary. The pairs are kept in the order they were added to the dictionary.

### Constructor Detail

#### COSDictionary

    public COSDictionary()

Constructor.

#### COSDictionary

    public COSDictionary(COSDictionary dict)

Copy Constructor. This will make a shallow copy of this dictionary.

Parameters:
  `dict` - The dictionary to copy.

### Method Detail

#### containsValue

    public boolean containsValue(Object value)

Parameters:
  `value` - The value to find in the map.
Returns:
  true if the map contains this value.
See Also:
  `Map.containsValue(java.lang.Object)`

#### getKeyForValue

    public COSName getKeyForValue(Object value)

Search in the map for the value that matches the parameter and return the first key that maps to that value.

Parameters:
  `value` - The value to search for in the map.
Returns:
  The key for the value in the map or null if it does not exist.

#### size

    public int size()

This will return the number of elements in this dictionary.

Returns:
  The number of elements in the dictionary.

#### clear

    public void clear()

This will clear all items in the map.

#### getDictionaryObject

    public COSBase getDictionaryObject(String key)

This will get an object from this dictionary. If the object is a reference then it will dereference it and get it from the document. If the object is COSNull then null will be returned.

Parameters:
  `key` - The key to the object that we are getting.
Returns:
  The object that matches the key.

#### getDictionaryObject

    public COSBase getDictionaryObject(COSName firstKey,
                                       COSName secondKey)

This is a special case of getDictionaryObject that takes multiple keys, it will handle the situation where multiple keys could get the same value, ie if either CS or ColorSpace is used to get the colorspace. This will get an object from this dictionary. If the object is a reference then it will dereference it and get it from the document. If the object is COSNull then null will be returned.

Parameters:
  `firstKey` - The first key to try.
  `secondKey` - The second key to try.
Returns:
  The object that matches the key.

#### getDictionaryObject

    public COSBase getDictionaryObject(String[] keyList)

Deprecated. Will be removed in 3.0. A value may have to keys, the regular one and sometimes an additional abbreviation. More than 2 values doesn't make sense.
This is a special case of getDictionaryObject that takes multiple keys, it will handle the situation where multiple keys could get the same value, ie if either CS or ColorSpace is used to get the colorspace. This will get an object from this dictionary. If the object is a reference then it will dereference it and get it from the document. If the object is COSNull then null will be returned.

Parameters:
  `keyList` - The list of keys to find a value.
Returns:
  The object that matches the key.

#### getDictionaryObject

    public COSBase getDictionaryObject(COSName key)

This will get an object from this dictionary. If the object is a reference then it will dereference it and get it from the document. If the object is COSNull then null will be returned.

Parameters:
  `key` - The key to the object that we are getting.
Returns:
  The object that matches the key.

#### setItem

    public void setItem(COSName key,
                        COSBase value)

This will set an item in the dictionary. If value is null then the result will be the same as removeItem( key ).

Parameters:
  `key` - The key to the dictionary object.
  `value` - The value to the dictionary object.

#### setItem

    public void setItem(COSName key,
                        COSObjectable value)

This will set an item in the dictionary. If value is null then the result will be the same as removeItem( key ).

Parameters:
  `key` - The key to the dictionary object.
  `value` - The value to the dictionary object.

#### setItem

    public void setItem(String key,
                        COSObjectable value)

This will set an item in the dictionary. If value is null then the result will be the same as removeItem( key ).

Parameters:
  `key` - The key to the dictionary object.
  `value` - The value to the dictionary object.

#### setBoolean

    public void setBoolean(String key,
                           boolean value)

This will set an item in the dictionary.

Parameters:
  `key` - The key to the dictionary object.
  `value` - The value to the dictionary object.

#### setBoolean

    public void setBoolean(COSName key,
                           boolean value)

This will set an item in the dictionary.

Parameters:
  `key` - The key to the dictionary object.
  `value` - The value to the dictionary object.

#### setItem

    public void setItem(String key,
                        COSBase value)

This will set an item in the dictionary. If value is null then the result will be the same as removeItem( key ).

Parameters:
  `key` - The key to the dictionary object.
  `value` - The value to the dictionary object.

#### setName

    public void setName(String key,
                        String value)

This is a convenience method that will convert the value to a COSName object. If it is null then the object will be removed.

Parameters:
  `key` - The key to the object,
  `value` - The string value for the name.

#### setName

    public void setName(COSName key,
                        String value)

This is a convenience method that will convert the value to a COSName object. If it is null then the object will be removed.

Parameters:
  `key` - The key to the object,
  `value` - The string value for the name.

#### setDate

    public void setDate(String key,
                        Calendar date)

Set the value of a date entry in the dictionary.

Parameters:
  `key` - The key to the date value.
  `date` - The date value.

#### setDate

    public void setDate(COSName key,
                        Calendar date)

Set the date object.

Parameters:
  `key` - The key to the date.
  `date` - The date to set.

#### setEmbeddedDate

    public void setEmbeddedDate(String embedded,
                                String key,
                                Calendar date)

Set the value of a date entry in the dictionary.

Parameters:
  `embedded` - The embedded dictionary.
  `key` - The key to the date value.
  `date` - The date value.

#### setEmbeddedDate

    public void setEmbeddedDate(String embedded,
                                COSName key,
                                Calendar date)

Set the date object.

Parameters:
  `embedded` - The embedded dictionary.
  `key` - The key to the date.
  `date` - The date to set.

#### setString

    public void setString(String key,
                          String value)

This is a convenience method that will convert the value to a COSString object. If it is null then the object will be removed.

Parameters:
  `key` - The key to the object,
  `value` - The string value for the name.

#### setString

    public void setString(COSName key,
                          String value)

This is a convenience method that will convert the value to a COSString object. If it is null then the object will be removed.

Parameters:
  `key` - The key to the object,
  `value` - The string value for the name.

#### setEmbeddedString

    public void setEmbeddedString(String embedded,
                                  String key,
                                  String value)

This is a convenience method that will convert the value to a COSString object. If it is null then the object will be removed.

Parameters:
  `embedded` - The embedded dictionary to set the item in.
  `key` - The key to the object,
  `value` - The string value for the name.

#### setEmbeddedString

    public void setEmbeddedString(String embedded,
                                  COSName key,
                                  String value)

This is a convenience method that will convert the value to a COSString object. If it is null then the object will be removed.

Parameters:
  `embedded` - The embedded dictionary to set the item in.
  `key` - The key to the object,
  `value` - The string value for the name.

#### setInt

    public void setInt(String key,
                       int value)

This is a convenience method that will convert the value to a COSInteger object.

Parameters:
  `key` - The key to the object,
  `value` - The int value for the name.

#### setInt

    public void setInt(COSName key,
                       int value)

This is a convenience method that will convert the value to a COSInteger object.

Parameters:
  `key` - The key to the object,
  `value` - The int value for the name.

#### setLong

    public void setLong(String key,
                        long value)

This is a convenience method that will convert the value to a COSInteger object.

Parameters:
  `key` - The key to the object,
  `value` - The int value for the name.

#### setLong

    public void setLong(COSName key,
                        long value)

This is a convenience method that will convert the value to a COSInteger object.

Parameters:
  `key` - The key to the object,
  `value` - The int value for the name.

#### setEmbeddedInt

    public void setEmbeddedInt(String embeddedDictionary,
                               String key,
                               int value)

This is a convenience method that will convert the value to a COSInteger object.

Parameters:
  `embeddedDictionary` - The embedded dictionary.
  `key` - The key to the object,
  `value` - The int value for the name.

#### setEmbeddedInt

    public void setEmbeddedInt(String embeddedDictionary,
                               COSName key,
                               int value)

This is a convenience method that will convert the value to a COSInteger object.

Parameters:
  `embeddedDictionary` - The embedded dictionary.
  `key` - The key to the object,
  `value` - The int value for the name.

#### setFloat

    public void setFloat(String key,
                         float value)

This is a convenience method that will convert the value to a COSFloat object.

Parameters:
  `key` - The key to the object,
  `value` - The int value for the name.

#### setFloat

    public void setFloat(COSName key,
                         float value)

This is a convenience method that will convert the value to a COSFloat object.

Parameters:
  `key` - The key to the object,
  `value` - The int value for the name.

#### setFlag

    public void setFlag(COSName field,
                        int bitFlag,
                        boolean value)

Sets the given boolean value at bitPos in the flags.

Parameters:
  `field` - The COSName of the field to set the value into.
  `bitFlag` - the bit position to set the value in.
  `value` - the value the bit position should have.

#### getCOSName

    public COSName getCOSName(COSName key)

This is a convenience method that will get the dictionary object that is expected to be a name. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The COS name.

#### getCOSObject

    public COSObject getCOSObject(COSName key)

This is a convenience method that will get the dictionary object that is expected to be a COSObject. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The COSObject.

#### getCOSDictionary

    public COSDictionary getCOSDictionary(COSName key)

This is a convenience method that will get the dictionary object that is expected to be a COSDictionary. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The COSDictionary.

#### getCOSStream

    public COSStream getCOSStream(COSName key)

This is a convenience method that will get the dictionary object that is expected to be a COSStream. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The COSStream.

#### getCOSArray

    public COSArray getCOSArray(COSName key)

This is a convenience method that will get the dictionary object that is expected to be a COSArray. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The COSArray.

#### getCOSName

    public COSName getCOSName(COSName key,
                              COSName defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a name. Default is returned if the entry does not exist in the dictionary.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The COS name.

#### getNameAsString

    public String getNameAsString(String key)

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The name converted to a string.

#### getNameAsString

    public String getNameAsString(COSName key)

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The name converted to a string.

#### getNameAsString

    public String getNameAsString(String key,
                                  String defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The name converted to a string.

#### getNameAsString

    public String getNameAsString(COSName key,
                                  String defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The name converted to a string.

#### getString

    public String getString(String key)

This is a convenience method that will get the dictionary object that is expected to be a string. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The name converted to a string.

#### getString

    public String getString(COSName key)

This is a convenience method that will get the dictionary object that is expected to be a string. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The name converted to a string.

#### getString

    public String getString(String key,
                            String defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a string.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The default value to return.
Returns:
  The name converted to a string.

#### getString

    public String getString(COSName key,
                            String defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a string.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The default value to return.
Returns:
  The name converted to a string.

#### getEmbeddedString

    public String getEmbeddedString(String embedded,
                                    String key)

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `embedded` - The embedded dictionary.
  `key` - The key to the item in the dictionary.
Returns:
  The name converted to a string.

#### getEmbeddedString

    public String getEmbeddedString(String embedded,
                                    COSName key)

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `embedded` - The embedded dictionary.
  `key` - The key to the item in the dictionary.
Returns:
  The name converted to a string.

#### getEmbeddedString

    public String getEmbeddedString(String embedded,
                                    String key,
                                    String defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.

Parameters:
  `embedded` - The embedded dictionary.
  `key` - The key to the item in the dictionary.
  `defaultValue` - The default value to return.
Returns:
  The name converted to a string.

#### getEmbeddedString

    public String getEmbeddedString(String embedded,
                                    COSName key,
                                    String defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string.

Parameters:
  `embedded` - The embedded dictionary.
  `key` - The key to the item in the dictionary.
  `defaultValue` - The default value to return.
Returns:
  The name converted to a string.

#### getDate

    public Calendar getDate(String key)

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string. Null is returned if the entry does not exist in the dictionary or if the date was invalid.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The name converted to a date.

#### getDate

    public Calendar getDate(COSName key)

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string. Null is returned if the entry does not exist in the dictionary or if the date was invalid.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The name converted to a date.

#### getDate

    public Calendar getDate(String key,
                            Calendar defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a date.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The default value to return if the entry does not exist in the dictionary or if the date was invalid.
Returns:
  The name converted to a date.

#### getDate

    public Calendar getDate(COSName key,
                            Calendar defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a date.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The default value to return if the entry does not exist in the dictionary or if the date was invalid.
Returns:
  The name converted to a date.

#### getEmbeddedDate

    public Calendar getEmbeddedDate(String embedded,
                                    String key)
                             throws IOException

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `embedded` - The embedded dictionary to get.
  `key` - The key to the item in the dictionary.
Returns:
  The name converted to a string.
Throws:
  `IOException` - If there is an error converting to a date.

#### getEmbeddedDate

    public Calendar getEmbeddedDate(String embedded,
                                    COSName key)
                             throws IOException

This is a convenience method that will get the dictionary object that is expected to be a name and convert it to a string. Null is returned if the entry does not exist in the dictionary.

Parameters:
  `embedded` - The embedded dictionary to get.
  `key` - The key to the item in the dictionary.
Returns:
  The name converted to a string.
Throws:
  `IOException` - If there is an error converting to a date.

#### getEmbeddedDate

    public Calendar getEmbeddedDate(String embedded,
                                    String key,
                                    Calendar defaultValue)
                             throws IOException

This is a convenience method that will get the dictionary object that is expected to be a date.

Parameters:
  `embedded` - The embedded dictionary to get.
  `key` - The key to the item in the dictionary.
  `defaultValue` - The default value to return if the entry does not exist in the dictionary or if the date was invalid.
Returns:
  The name converted to a string.
Throws:
  `IOException` - If there is an error converting to a date.

#### getEmbeddedDate

    public Calendar getEmbeddedDate(String embedded,
                                    COSName key,
                                    Calendar defaultValue)
                             throws IOException

This is a convenience method that will get the dictionary object that is expected to be a date.

Parameters:
  `embedded` - The embedded dictionary to get.
  `key` - The key to the item in the dictionary.
  `defaultValue` - The default value to return if the entry does not exist in the dictionary or if the date was invalid.
Returns:
  The name converted to a string.
Throws:
  `IOException` - If there is an error converting to a date.

#### getBoolean

    public boolean getBoolean(String key,
                              boolean defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a cos boolean and convert it to a primitive boolean.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value returned if the entry is null.
Returns:
  The value converted to a boolean.

#### getBoolean

    public boolean getBoolean(COSName key,
                              boolean defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a COSBoolean and convert it to a primitive boolean.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value returned if the entry is null.
Returns:
  The entry converted to a boolean.

#### getBoolean

    public boolean getBoolean(COSName firstKey,
                              COSName secondKey,
                              boolean defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a COSBoolean and convert it to a primitive boolean.

Parameters:
  `firstKey` - The first key to the item in the dictionary.
  `secondKey` - The second key to the item in the dictionary.
  `defaultValue` - The value returned if the entry is null.
Returns:
  The entry converted to a boolean.

#### getEmbeddedInt

    public int getEmbeddedInt(String embeddedDictionary,
                              String key)

Get an integer from an embedded dictionary. Useful for 1-1 mappings. default:-1

Parameters:
  `embeddedDictionary` - The name of the embedded dictionary.
  `key` - The key in the embedded dictionary.
Returns:
  The value of the embedded integer.

#### getEmbeddedInt

    public int getEmbeddedInt(String embeddedDictionary,
                              COSName key)

Get an integer from an embedded dictionary. Useful for 1-1 mappings. default:-1

Parameters:
  `embeddedDictionary` - The name of the embedded dictionary.
  `key` - The key in the embedded dictionary.
Returns:
  The value of the embedded integer.

#### getEmbeddedInt

    public int getEmbeddedInt(String embeddedDictionary,
                              String key,
                              int defaultValue)

Get an integer from an embedded dictionary. Useful for 1-1 mappings.

Parameters:
  `embeddedDictionary` - The name of the embedded dictionary.
  `key` - The key in the embedded dictionary.
  `defaultValue` - The value if there is no embedded dictionary or it does not contain the key.
Returns:
  The value of the embedded integer.

#### getEmbeddedInt

    public int getEmbeddedInt(String embeddedDictionary,
                              COSName key,
                              int defaultValue)

Get an integer from an embedded dictionary. Useful for 1-1 mappings.

Parameters:
  `embeddedDictionary` - The name of the embedded dictionary.
  `key` - The key in the embedded dictionary.
  `defaultValue` - The value if there is no embedded dictionary or it does not contain the key.
Returns:
  The value of the embedded integer.

#### getInt

    public int getInt(String key)

This is a convenience method that will get the dictionary object that is expected to be an int. -1 is returned if there is no value.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The integer value.

#### getInt

    public int getInt(COSName key)

This is a convenience method that will get the dictionary object that is expected to be an int. -1 is returned if there is no value.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The integer value..

#### getInt

    public int getInt(String[] keyList,
                      int defaultValue)

Deprecated. Will be removed in 3.0. A value may have to keys, the regular one and sometimes an additional abbreviation. More than 2 values doesn't make sense.
This is a convenience method that will get the dictionary object that is expected to be an integer. If the dictionary value is null then the default value will be returned.

Parameters:
  `keyList` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The integer value.

#### getInt

    public int getInt(String key,
                      int defaultValue)

This is a convenience method that will get the dictionary object that is expected to be an integer. If the dictionary value is null then the default value will be returned.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The integer value.

#### getInt

    public int getInt(COSName key,
                      int defaultValue)

This is a convenience method that will get the dictionary object that is expected to be an integer. If the dictionary value is null then the default value will be returned.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The integer value.

#### getInt

    public int getInt(COSName firstKey,
                      COSName secondKey)

This is a convenience method that will get the dictionary object that is expected to be an integer. If the dictionary value is null then the default value -1 will be returned.

Parameters:
  `firstKey` - The first key to the item in the dictionary.
  `secondKey` - The second key to the item in the dictionary.
Returns:
  The integer value.

#### getInt

    public int getInt(COSName firstKey,
                      COSName secondKey,
                      int defaultValue)

This is a convenience method that will get the dictionary object that is expected to be an integer. If the dictionary value is null then the default value will be returned.

Parameters:
  `firstKey` - The first key to the item in the dictionary.
  `secondKey` - The second key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The integer value.

#### getLong

    public long getLong(String key)

This is a convenience method that will get the dictionary object that is expected to be an long. -1 is returned if there is no value.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The long value.

#### getLong

    public long getLong(COSName key)

This is a convenience method that will get the dictionary object that is expected to be an long. -1 is returned if there is no value.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The long value.

#### getLong

    public long getLong(String[] keyList,
                        long defaultValue)

Deprecated. Will be removed in 3.0. A value may have to keys, the regular one and sometimes an additional abbreviation. More than 2 values doesn't make sense.
This is a convenience method that will get the dictionary object that is expected to be an long. If the dictionary value is null then the default value will be returned.

Parameters:
  `keyList` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The long value.

#### getLong

    public long getLong(String key,
                        long defaultValue)

This is a convenience method that will get the dictionary object that is expected to be an integer. If the dictionary value is null then the default value will be returned.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The integer value.

#### getLong

    public long getLong(COSName key,
                        long defaultValue)

This is a convenience method that will get the dictionary object that is expected to be an integer. If the dictionary value is null then the default value will be returned.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The integer value.

#### getFloat

    public float getFloat(String key)

This is a convenience method that will get the dictionary object that is expected to be an float. -1 is returned if there is no value.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The float value.

#### getFloat

    public float getFloat(COSName key)

This is a convenience method that will get the dictionary object that is expected to be an float. -1 is returned if there is no value.

Parameters:
  `key` - The key to the item in the dictionary.
Returns:
  The float value.

#### getFloat

    public float getFloat(String key,
                          float defaultValue)

This is a convenience method that will get the dictionary object that is expected to be a float. If the dictionary value is null then the default value will be returned.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The float value.

#### getFloat

    public float getFloat(COSName key,
                          float defaultValue)

This is a convenience method that will get the dictionary object that is expected to be an float. If the dictionary value is null then the default value will be returned.

Parameters:
  `key` - The key to the item in the dictionary.
  `defaultValue` - The value to return if the dictionary item is null.
Returns:
  The float value.

#### getFlag

    public boolean getFlag(COSName field,
                           int bitFlag)

Gets the boolean value from the flags at the given bit position.

Parameters:
  `field` - The COSName of the field to get the flag from.
  `bitFlag` - the bitPosition to get the value from.
Returns:
  true if the number at bitPos is '1'

#### removeItem

    public void removeItem(COSName key)

This will remove an item for the dictionary. This will do nothing of the object does not exist.

Parameters:
  `key` - The key to the item to remove from the dictionary.

#### getItem

    public COSBase getItem(COSName key)

This will do a lookup into the dictionary.

Parameters:
  `key` - The key to the object.
Returns:
  The item that matches the key.

#### getItem

    public COSBase getItem(String key)

This will do a lookup into the dictionary.

Parameters:
  `key` - The key to the object.
Returns:
  The item that matches the key.

#### getItem

    public COSBase getItem(COSName firstKey,
                           COSName secondKey)

This is a special case of getItem that takes multiple keys, it will handle the situation where multiple keys could get the same value, ie if either CS or ColorSpace is used to get the colorspace. This will get an object from this dictionary.

Parameters:
  `firstKey` - The first key to try.
  `secondKey` - The second key to try.
Returns:
  The object that matches the key.

#### keySet

    public Set<COSName> keySet()

Returns the names of the entries in this dictionary. The returned set is in the order the entries were added to the dictionary.

Returns:
  names of the entries in this dictionary
Since:
  Apache PDFBox 1.1.0

#### entrySet

    public Set<Map.Entry<COSName,COSBase>> entrySet()

Returns the name-value entries in this dictionary. The returned set is in the order the entries were added to the dictionary.

Returns:
  name-value entries in this dictionary
Since:
  Apache PDFBox 1.1.0

#### getValues

    public Collection<COSBase> getValues()

This will get all of the values for the dictionary.

Returns:
  All the values for the dictionary.

#### accept

    public Object accept(ICOSVisitor visitor)
                  throws IOException

visitor pattern double dispatch method.

Specified by:
  `accept` in class `COSBase`
Parameters:
  `visitor` - The object to notify when visiting this object.
Returns:
  The object that the visitor returns.
Throws:
  `IOException` - If there is an error visiting this object.

#### isNeedToBeUpdated

    public boolean isNeedToBeUpdated()

Description copied from interface: `COSUpdateInfo`
Get the update state for the COSWriter. This indicates whether an object is to be written when there is an incremental save.

Specified by:
  `isNeedToBeUpdated` in interface `COSUpdateInfo`
Returns:
  the update state.

#### setNeedToBeUpdated

    public void setNeedToBeUpdated(boolean flag)

Description copied from interface: `COSUpdateInfo`
Set the update state of the dictionary for the COSWriter. This indicates whether an object is to be written when there is an incremental save.

Specified by:
  `setNeedToBeUpdated` in interface `COSUpdateInfo`
Parameters:
  `flag` - the update state.

#### addAll

    public void addAll(COSDictionary dict)

This will add all of the dictionaries keys/values to this dictionary. Existing key/value pairs will be overwritten.

Parameters:
  `dict` - The dictionaries to get the key/value pairs from.

#### containsKey

    public boolean containsKey(COSName name)

Parameters:
  `name` - The key to find in the map.
Returns:
  true if the map contains this key.
See Also:
  `Map.containsKey(Object)`

#### containsKey

    public boolean containsKey(String name)

Parameters:
  `name` - The key to find in the map.
Returns:
  true if the map contains this key.
See Also:
  `Map.containsKey(Object)`

#### mergeInto

    @Deprecated
    public void mergeInto(COSDictionary dic)

Deprecated. This method should no longer be used and will be removed in 3.0 because it could also merge attributes that should not be merged (filter and length) in a COSStream.
This will add all of the dictionaries keys/values to this dictionary, but only if they don't already exist. If a key already exists in this dictionary then nothing is changed.

Parameters:
  `dic` - The dictionaries to get the keys from.

#### getObjectFromPath

    public COSBase getObjectFromPath(String objPath)

Nice method, gives you every object you want Arrays works properly too. Try "P/Annots/[k]/Rect" where k means the index of the Annotsarray.

Parameters:
  `objPath` - the relative path to the object.
Returns:
  the object

#### asUnmodifiableDictionary

    public COSDictionary asUnmodifiableDictionary()

Returns an unmodifiable view of this dictionary.

Returns:
  an unmodifiable view of this dictionary

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`